<?php
/******************************************************************************
* shout.php	                                                              *
*******************************************************************************
* SMF: Simple Machines Forum - Ultimate Shoutbox MOD                          *
* Open-Source Project Inspired by Zef Hemel (zef@zefhemel.com)                *
* =========================================================================== *
* Software Version:           1.39  	                                      *
* Software originally by:     Greg Haase				      *
* Ported to SMF by:	      Matthew Wolf (a.k.a Grudge)    		      *
* Support, News, Updates at:  http://www.simplemachines.org                   *
*******************************************************************************
* This program is free software; you may redistribute it and/or modify it     *
* under the terms of the provided license as published by Lewis Media.        *
*                                                                             *
* This program is distributed in the hope that it is and will be useful,      *
* but WITHOUT ANY WARRANTIES; without even any implied warranty of            *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                        *
*                                                                             *
* See the "license.txt" file for details of the Simple Machines license.      *
* The latest version can always be found at http://www.simplemachines.org.    *
******************************************************************************/

if (!defined('SMF'))
	die('Hacking attempt...');

function shout_display($showform = true)
{
	global $user_info, $db_prefix, $modSettings, $settings, $sourcedir, $scripturl, $txt, $context;

	// Load the template!
	loadTemplate('shout');

	$context['canDelete'] = allowedTo('delete_shout');
	$context['canPost'] = allowedTo('make_shout');

	// This just allows the user to show the form separately if necessary!
	$context['show_shout_form'] = $showform;

	// Store the URL for deletion.
	$context['url_direct'] = empty($_SERVER['REQUEST_URL']) || !empty($modSettings['shout_enableXML']) ? '' : ';redir=' . base64_encode($_SERVER['REQUEST_URL']);

	$request = db_query("
		SELECT * 
		FROM {$db_prefix}shoutbox
		ORDER BY ID_SHOUT DESC 
		LIMIT " . (empty($modSettings['shoutlimit']) ? 5 : (int) $modSettings['shoutlimit']), __FILE__, __LINE__);
	$context['shouts'] = array();
	while($row = mysql_fetch_assoc($request))
	{
		$row['message'] = censorText($row['message']);

		// This is Chiani's Magic Make Long Words Short Words Recipe
		// Pay attention, this gets complicated
		if (!empty($modSettings['shoutmaxchr']))
		{
			$message = explode(' ', $row['message']);

			for ($mcounter = 0, $mlimit = count($message); $mcounter < $mlimit; $mcounter++)
			{
				$wordlength = strlen($message[$mcounter]);

				if ($wordlength > $modSettings['shoutmaxchr']) 
				{
					$firsthalf = substr($message[$mcounter], 0, $modSettings['shoutsplitchr']) . '...';
					$secondhalf = substr($message[$mcounter], $modSettings['shoutsplitchr'] - $wordlength);
					$returned = array_splice($message, $mcounter, 1, array($firsthalf, $secondhalf));
				}
			}

			$row['message'] = implode(' ', $message);
		}
	
		// Get the smilies and the BBC so it looks all pretty
		$row['message'] = doUBBC($row['message']);

		$context['shouts'][] = array(
			'time' => timeformat($row['time']),
			'id' => $row['ID_SHOUT'],
			'message' => $row['message'],
			'memberID' => $row['ID_MEMBER'],
			'displayname' => $row['displayname'],
			'email' => $row['email'],
			'link' => empty($row['ID_MEMBER']) ? $row['displayname'] : ('<a href="' . $scripturl . '?action=profile;u=' . $row['ID_MEMBER'] . '">' . $row['displayname'] . '</a>'),
		);
	}
	mysql_free_result($request);

	if (!empty($modSettings['shoutdir']))
		$context['shouts'] = array_reverse($context['shouts']);

	// Handle the case of it being an XML request
	if (isset($_REQUEST['xml']))
	{
		$context['shouts'] = htmlspecialchars__recursive($context['shouts']);
		// Bypass the obExit, as it won't work nice with 1.02 otherwise ;)
		header('Content-type: text/xml');
		template_xml_shout();
		exit;
	}

	// Run the template!
	template_shout_box();	
}

function ShoutArchive()
{
	global $user_info, $db_prefix, $modSettings, $settings, $txt, $sourcedir, $scripturl, $context, $start;

	loadTemplate('shout');

	$context['page_title'] = $txt['shoutbox_1'];
	$context['sub_template'] = 'shout_archive';

	$perPage = 20;

	$start = isset($_REQUEST['start']) ? (int) $_REQUEST['start'] : 0;

	$request = db_query("
		SELECT COUNT(ID_SHOUT)
		FROM {$db_prefix}shoutbox
		LIMIT 1", __FILE__, __LINE__);
	list ($totalShouts) = mysql_fetch_row($request);
	mysql_free_result($request);

	$context['url_direct'] = empty($_SERVER['REQUEST_URL']) || !empty($modSettings['shout_enableXML']) ? '' : ';redir=' . base64_encode($_SERVER['REQUEST_URL']);
	$context['page_index'] = constructPageIndex($scripturl . '?action=shout_archive', $start, $totalShouts, $perPage, false);

	$context['qstr'] = "http://" . $_SERVER['HTTP_HOST'] . $_SERVER['PHP_SELF'] . "?" . $_SERVER['QUERY_STRING'];
	$context['canPost'] = allowedTo('make_shout');
	$context['canDelete'] = allowedTo('delete_shout');
	
	if (strcmp( substr($_SERVER['PHP_SELF'], -7), "SSI.php") == 0)
		$context['qstr'] = "http://" . $_SERVER['HTTP_HOST'];

	$request = db_query("
		SELECT *
		FROM {$db_prefix}shoutbox
		ORDER BY ID_SHOUT " . ($modSettings['shoutdir'] != 0 ? 'ASC' : 'DESC') . "
		LIMIT $start, $perPage", __FILE__, __LINE__);

	//Loop through the results and print them to the screen
	$context['arc_shouts'] = array();
	while($row = mysql_fetch_array($request))
		$context['arc_shouts'][] = array(
			'time' => timeformat($row['time']),
			'id' => $row['ID_SHOUT'],
			'message' => doUBBC(censorText($row['message'])),
			'memberID' => $row['ID_MEMBER'],
			'displayname' => $row['displayname'],
			'email' => $row['email'],
			'link' => empty($row['ID_MEMBER']) ? $row['displayname'] : ('<a href="' . $scripturl . '?action=profile;u=' . $row['ID_MEMBER'] . '">' . $row['displayname'] . '</a>'),
		);
	mysql_free_result($request);
}

function shout_form()
{
	global $user_info, $settings, $modSettings, $scripturl, $context;

	$context['qstr'] = "http://" . $_SERVER['HTTP_HOST'] . $_SERVER['PHP_SELF'] . "?" . $_SERVER['QUERY_STRING'];
	
	if (strcmp( substr($_SERVER['PHP_SELF'], -7), "SSI.php") == 0)
		$context['qstr'] = "http://" . $_SERVER['HTTP_HOST'];

	$canPost = allowedTo('make_shout');

	if (!$canPost)
		return;

	// Now do the printing...
	loadTemplate('shout');
	// Run the template!
	template_shout_form();	

}

function Shout()
{
	global $db_prefix, $user_info, $settings, $modSettings, $txt, $user_info, $sourcedir, $ID_MEMBER;

	checkSession('post');

	isAllowedTo('make_shout');

	$time = time();

	$_POST['message'] = isset($_POST['message']) ? $_POST['message'] : '';
	$_POST['displayname'] = isset($_POST['displayname']) ? trim($_POST['displayname']) : '';
	$_POST['memberID'] = (int) $_POST['memberID'];
	$message = $_POST['message'];

	//Put a space in front of the message - so we can just enter 1 smiley. We make up for it in the display
	$message = " " . $message . " ";

	$message = htmlspecialchars($message, ENT_QUOTES);
	include_once($sourcedir . '/Subs-Post.php');
	preparsecode($message);
	//Here we put in some validation so we don't have to put up with too much crap

	//make sure all the fields are filled in
	if (($_POST['displayname'] == "") || ($_POST['message'] == ""))
		fatal_error($txt['shoutbox_11'], false);

	//make sure nobody hit submit without filling in all the fields
	if (($_POST['displayname'] == $txt['shoutbox_6']) || ($_POST['email'] == $txt['shoutbox_7']) || ($_POST['message'] == $txt['shoutbox_8']))
		fatal_error($txt['shoutbox_11'], false);
	
	//make sure nobody puts in a bogus email address
	if ($user_info['is_guest'] &&  empty($modSettings['shout_noGuestEmail']) && preg_match('~^[0-9A-Za-z=_+\-/][0-9A-Za-z=_\'+\-/\.]+@[\w\-]+(\.[\w\-]+)*(\.[\w]{2,6})$~', $_POST['email']) == 0)
		fatal_error($txt['shoutbox_12'], false);

	// Ensure this name isn't reserved.
	if ($user_info['is_guest'])
	{
		// New versions have it in Subs-Members...
		if (!function_exists('isReservedName'))
			include_once($sourcedir . '/Subs-Members.php');

		if (isReservedName($_POST['displayname']))
			fatal_lang_error(244, true, array($_POST['displayname']));

		// Clean the name!
		$_POST['displayname'] = htmlspecialchars($_POST['displayname']);
		$_POST['email'] = htmlspecialchars($_POST['email']);
	}
	else
	{
		$_POST['displayname'] = $user_info['name'];
		$_POST['email'] = $user_info['email'];
		$_POST['memberID'] = $ID_MEMBER;
	}

	if ($_POST['displayname'] == '')
		$_POST['displayname'] = $user_info['name'];
	if ($_POST['email'] == '')
		$_POST['email'] = 'na';

	// Now we're ready to insert the shout
	$result = db_query("
		INSERT INTO {$db_prefix}shoutbox
		(ID_MEMBER, displayname, message,time,email)
		VALUES ($_POST[memberID], '$_POST[displayname]', '$message','$time','$_POST[email]')", __FILE__, __LINE__);

	ob_end_clean();
	header("Location: $_POST[qstr]");
	obExit(false);
}

function delete_shout()
{
	global $db_prefix, $user_info;

	checkSession('request');

	$to_delete = array();
	if (isset($_POST['delete_sel']) && !empty($_POST['ind_delete']))
	{
		foreach ($_POST['ind_delete'] as $id)
			$to_delete[] = (int) $id;
	}
	elseif (isset($_REQUEST['sid']))
		$to_delete[] = (int) $_REQUEST['sid'];

	isAllowedTo('delete_shout');

	if (!empty($to_delete))
		$result = db_query("
			DELETE
			FROM {$db_prefix}shoutbox
			WHERE ID_SHOUT IN (" . implode(',', $to_delete) . ")", __FILE__, __LINE__);

	if (!empty($_GET['redir']))
	{
		$redir = base64_decode($_GET['redir']);
		if (strpos($redir, 'action=delete') === false)
			redirectexit($redir);
	}
	elseif (!empty($_SESSION['old_url']))
		redirectexit($_SESSION['old_url']);

	redirectexit();
}

function delete_all_shouts()
{
	global $txt, $db_prefix, $modSettings, $scripturl;

	checkSession('post');

	isAllowedTo('delete_shout');

	$result = db_query("
		SELECT ID_SHOUT
		FROM {$db_prefix}shoutbox
		ORDER BY ID_SHOUT DESC
		LIMIT $modSettings[shoutlimit], 1", __FILE__, __LINE__);
	$row = mysql_fetch_assoc($result);
	mysql_free_result($result);

	// Delete everything in the database that has that id or lower.
	if (isset($row['ID_SHOUT']))
		db_query("
			DELETE FROM {$db_prefix}shoutbox
			WHERE ID_SHOUT < $row[ID_SHOUT]", __FILE__, __LINE__);
	ShoutArchive();
}

function delete_shout_age()
{
	global $txt, $db_prefix, $modSettings, $scripturl, $age, $notice, $msg;

	isAllowedTo('delete_shout');

	$request = db_query("
		DELETE
		FROM {$db_prefix}shoutbox
		WHERE time < " . (time() - 3600 * 24 * $age), __FILE__, __LINE__);
		
	ShoutArchive();
}

?>